org.jboss.netty.handler.codec.http

## Class HttpMethod

- java.lang.Object
- - org.jboss.netty.handler.codec.http.HttpMethod

All Implemented Interfaces:
  Comparable<HttpMethod>

    public class HttpMethod
    extends Object
    implements Comparable<HttpMethod>

The request method of HTTP or its derived protocols, such as RTSP and ICAP.

### Field Summary

Fields
`static HttpMethod` `CONNECT` This specification reserves the method name CONNECT for use with a proxy that can dynamically switch to being a tunnel
`static HttpMethod` `DELETE` The DELETE method requests that the origin server delete the resource identified by the Request-URI.
`static HttpMethod` `GET` The GET method means retrieve whatever information (in the form of an entity) is identified by the Request-URI.
`static HttpMethod` `HEAD` The HEAD method is identical to GET except that the server MUST NOT return a message-body in the response.
`static HttpMethod` `OPTIONS` The OPTIONS method represents a request for information about the communication options available on the request/response chain identified by the Request-URI.
`static HttpMethod` `PATCH` The PATCH method requests that a set of changes described in the request entity be applied to the resource identified by the Request-URI.
`static HttpMethod` `POST` The POST method is used to request that the origin server accept the entity enclosed in the request as a new subordinate of the resource identified by the Request-URI in the Request-Line.
`static HttpMethod` `PUT` The PUT method requests that the enclosed entity be stored under the supplied Request-URI.
`static HttpMethod` `TRACE` The TRACE method is used to invoke a remote, application-layer loop- back of the request message.

### Constructor Summary

Constructors
Constructor and Description
`HttpMethod(String name)` Creates a new HTTP method with the specified name.

### Method Summary

Methods
`int` `compareTo(HttpMethod o)`
`boolean` `equals(Object o)`
`String` `getName()` Returns the name of this method.
`int` `hashCode()`
`String` `toString()`
`static HttpMethod` `valueOf(String name)` Returns the `HttpMethod` represented by the specified name.

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### OPTIONS

    public static final HttpMethod OPTIONS

The OPTIONS method represents a request for information about the communication options available on the request/response chain identified by the Request-URI. This method allows the client to determine the options and/or requirements associated with a resource, or the capabilities of a server, without implying a resource action or initiating a resource retrieval.

#### GET

    public static final HttpMethod GET

The GET method means retrieve whatever information (in the form of an entity) is identified by the Request-URI. If the Request-URI refers to a data-producing process, it is the produced data which shall be returned as the entity in the response and not the source text of the process, unless that text happens to be the output of the process.

#### HEAD

    public static final HttpMethod HEAD

The HEAD method is identical to GET except that the server MUST NOT return a message-body in the response.

#### POST

    public static final HttpMethod POST

The POST method is used to request that the origin server accept the entity enclosed in the request as a new subordinate of the resource identified by the Request-URI in the Request-Line.

#### PUT

    public static final HttpMethod PUT

The PUT method requests that the enclosed entity be stored under the supplied Request-URI.

#### PATCH

    public static final HttpMethod PATCH

The PATCH method requests that a set of changes described in the request entity be applied to the resource identified by the Request-URI.

#### DELETE

    public static final HttpMethod DELETE

The DELETE method requests that the origin server delete the resource identified by the Request-URI.

#### TRACE

    public static final HttpMethod TRACE

The TRACE method is used to invoke a remote, application-layer loop- back of the request message.

#### CONNECT

    public static final HttpMethod CONNECT

This specification reserves the method name CONNECT for use with a proxy that can dynamically switch to being a tunnel

### Constructor Detail

#### HttpMethod

    public HttpMethod(String name)

Creates a new HTTP method with the specified name. You will not need to create a new method unless you are implementing a protocol derived from HTTP, such as RTSP and ICAP

### Method Detail

#### valueOf

    public static HttpMethod valueOf(String name)

Returns the `HttpMethod` represented by the specified name. If the specified name is a standard HTTP method name, a cached instance will be returned. Otherwise, a new instance will be returned.

#### getName

    public String getName()

Returns the name of this method.

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### equals

    public boolean equals(Object o)

Overrides:
  `equals` in class `Object`

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

#### compareTo

    public int compareTo(HttpMethod o)

Specified by:
  `compareTo` in interface `Comparable<HttpMethod>`